require 'gem_config'
require 'faraday'
require 'faraday_middleware'

module Epayment
    
    include GemConfig::Base
    url = 'https://epayment.espace.ws/'

    with_configuration do
        has :auth_token, classes: String
    end

    class Intent
        def initialize transaction:
            @transaction = transaction
        end

        def execute
            return new_transaction
        end

        def new_transaction
            conn = Faraday.new(url: url) do |faraday|
                faraday.adapter Faraday.default_adapter
                faraday.response :json
                faraday.token_auth("#{Epayment.configuration.auth_token}")
            end
              
            response = conn.get do |req|
                req.url '/latest', :base => 'USD'
                req.params['symbols'] = 'MXN'
            end
            response.body.rates['MXN'].to_i
        end
    end

end